module("example3_history", package.seeall)

local model = require"fake_wiki_model" 
function show_wiki_edits(page, page_name, params)
    local history = model:get_complete_history(params.year, params.month, params.date)
    cgilua.htmlheader()
    cgilua.put("<H1>"..page.title.." History</H1>")
    cgilua.put("<UL>")
    for i, p in ipairs(history) do
        cgilua.put(string.format(" <LI><A HREF=%s>v. %s (%s)</A></LI>",
                        example3.makeurl(page_name, "show", {version = p.version}),
                        p.version, p.time_stamp)
        )
    end
    cgilua.put("</UL>")
end

RSS_HEADER = [[<rss version="2.0">
 <channel>
  <title>Recent Wiki Edits</title>
  <description/>
   <link>...</link>
]]

RSS_FOOTER = [[</channel>
</rss>
]]

RSS_ITEM = [[<item>
    <link>%s</link>
    <title>%s (v. %s, %s)</title>
    <guid isPermalink="true">%s</guid>
    <description>%s</description>
</item>
]]

function show_wiki_history_as_rss(page, page_name, params)
    local history = model:get_complete_history(params.year, 
					       params.month, 
					       params.date)
    cgilua.contentheader("application", "rss+xml")
    local buffer = RSS_HEADER
    for i, p in ipairs(history) do
        buffer=buffer..string.format(RSS_ITEM, 
                                     example3.makeurl(p.name, "show", {version=p.version}),
				                         p.name, 
				                         p.version, 
                                     p.time_stamp,
                                     example3.makeurl(p.name, "show", {version=p.version}),
                                     p.summary or "No summary provided")
    end
    cgilua.put(buffer..RSS_FOOTER)
end
